/*
 ============================================================================

  This program is free software, released under the GNU General Public License
  (GPL version 2 or later).

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  for more details.

  http://www.fsf.org/licenses/gpl.html

 ============================================================================
*/

#include "BBFooPlaylist.h"

char *plugin_info[] =
{
	"BBFooPlaylist 0.0.3b",
	"BBFooPlaylist",
	"0.0.3b",
	"ysuke",
	"2006-08-18",
	"http://zzbb.hp.infoseek.co.jp/",
	"zb2_460@yahoo.co.jp",
	"@BBFooPlaylist.Activate"
};

#define szVersion       plugin_info[0]
#define szAppName       plugin_info[1]
#define szInfoVersion	plugin_info[2]
#define szInfoAuthor	plugin_info[3]
#define szInfoRelDate	plugin_info[4]
#define szInfoLink	plugin_info[5]
#define szInfoEmail	plugin_info[6]
#define szBroamList	plugin_info[7]


//===========================================================================

int beginPlugin(HINSTANCE hPluginInstance)
{
	WNDCLASS wc;
	hwndBlackbox = GetBBWnd();
	hInstance = hPluginInstance;

	// Register the window class...
	ZeroMemory(&wc,sizeof(wc));
	wc.lpfnWndProc = WndProc;			// our window procedure
	wc.hInstance = hPluginInstance;		// hInstance of .dll
	wc.lpszClassName = szAppName;		// our window class name
	if (!RegisterClass(&wc)) 
	{
		MessageBox(hwndBlackbox, "Error registering window class", szAppName, MB_OK | MB_ICONERROR | MB_TOPMOST);
		return 1;
	}

	// Create the window...
	hwndPlugin = CreateWindowEx(
						WS_EX_TOOLWINDOW,								// window style
						szAppName,										// our window class name
						NULL,											// NULL -> does not show up in task manager!
						0,
						0, 0, 0, 0,											// window height
						NULL,											// parent window
						NULL,											// no menu
						hPluginInstance,								// hInstance of .dll
						NULL);
	if (!hwndPlugin)
	{						   
		MessageBox(0, "Error creating window", szAppName, MB_OK | MB_ICONERROR | MB_TOPMOST);
		// Unregister Blackbox messages...
		SendMessage(hwndBlackbox, BB_UNREGISTERMESSAGE, (WPARAM)hwndPlugin, (LPARAM)msgs);
		return 1;
	}
	// Register to receive Blackbox messages...
	SendMessage(hwndBlackbox, BB_REGISTERMESSAGE, (WPARAM)hwndPlugin, (LPARAM)msgs);

	return 0;
}

//===========================================================================

void endPlugin(HINSTANCE hPluginInstance)
{
        DestroyWindow(hwndPlugin);
        SendMessage(hwndBlackbox, BB_UNREGISTERMESSAGE, (WPARAM)hwndPlugin, (LPARAM)msgs);
        UnregisterClass(szAppName, hPluginInstance);
}

//===========================================================================

LPCSTR pluginInfo(int field)
{
	switch (field)
	{
		default:
		case 0: return szVersion;
		case 1: return szAppName;
		case 2: return szInfoVersion;
		case 3: return szInfoAuthor;
		case 4: return szInfoRelDate;
		case 5: return szInfoLink;
		case 6: return szInfoEmail;
		case 7: return szBroamList;
	}
}

//===========================================================================

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case BB_BROADCAST:
		{
			szTemp = (char*)lParam;

			if (strnicmp(szTemp, "@BBFooPlaylist.", 15))
				return 0;
			szTemp += 15;

			if (!_strnicmp(szTemp, "PlayTrack ", 9)){
				tracknum = atoi(szTemp + 10);

				HWND hwndFoo2k = FindWindow(FOO_PLAYLIST_REMOTE_WND_CLASS, NULL);
				SendMessage(hwndFoo2k, WM_FOO_PLAYTRACK, tracknum, 0);
				ShowMenu(MakePlaylistMenu(false));
			}
			if (!_stricmp(szTemp, "Activate"))
			{
				ShowMenu(MakePlaylistMenu(true));
                        }
		} break;

 		// ==========
		default:
			return DefWindowProc(hwnd,message,wParam,lParam);
	}
	return 0;
}

//===========================================================================

Menu* MakePlaylistMenu(bool popup)
{
	HWND hwndFoo2k = FindWindow(FOO_PLAYLIST_REMOTE_WND_CLASS, NULL);

	Menu *main = MakeNamedMenu("foobar2000's playlist", "BBFP", popup);

	int nowPlaying = (int)SendMessage(hwndFoo2k, WM_FOO_GETNOWPLAYING, 0, 0);
	for(int i = 0; i < (int)SendMessage(hwndFoo2k, WM_FOO_GETPLAYLISTSIZE, 0, 0); i++)
	{
    		char caption[256], buf[256];
		SendMessage(hwndFoo2k, WM_FOO_GETPLAYLISTITEM, i, 0);
		GetWindowText(hwndFoo2k, caption, 255);
    		sprintf(buf, "@BBFooPlaylist.PlayTrack %d", i);
    		MakeMenuItem(main, caption, buf, (popup? i == nowPlaying : i == tracknum));
	}
	return main;
}

//===========================================================================
