// foo_playlist_remote.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "../SDK/foobar2000.h"
#include "foo_playlist_remote.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved )
{
    switch ( ul_reason_for_call )
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }

    return TRUE ;
}

// remote control window
HWND g_hwnd = NULL ;

// set of subscribed windows
THwndSet g_set_sub ;

// remote window procedure
LRESULT CALLBACK foo_PlaylistRemoteWndProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	if ( hWnd == g_hwnd )
	{
		switch ( uMessage )
		{
			case WM_FOO_GETPLAYLISTSIZE:
				return static_api_ptr_t<playlist_manager>()->activeplaylist_get_item_count();

			case WM_FOO_GETPLAYLISTITEM:
			{
				static_api_ptr_t<titleformat_compiler> compiler;
				service_ptr_t<titleformat_object> formatobj;
				compiler->compile(formatobj, "$if(%title%,$if2(%album artist%,%artist%) - %title%,%_filename_ext%)");

				metadb_handle_ptr handle;
				if (static_api_ptr_t<playlist_manager>()->activeplaylist_get_item_handle(handle, wParam))
				{
					pfc::string8 str;
					static_api_ptr_t<playback_control>()->playback_format_title_ex(handle, NULL, str, formatobj, NULL, play_control::display_level_all);
					pfc::stringcvt::string_ansi_from_utf8 cvt(str);
					SetWindowTextA(hWnd, cvt.get_ptr());

				}else{
					SetWindowTextA(hWnd, "");
				}
				formatobj.release();
			}
			return TRUE;
 
			case WM_FOO_PLAYTRACK:
			{
				static_api_ptr_t<playlist_manager>()->activeplaylist_execute_default_action(wParam);
			}
			return TRUE;

			case WM_FOO_GETNOWPLAYING:
				t_size playlistIndex, index;
				static_api_ptr_t<playlist_manager>()->get_playing_item_location(&playlistIndex, &index);
				return index;
		}
	}
	return DefWindowProc( hWnd, uMessage, wParam, lParam ) ;
}

// handles init and quit of plug-in
class initquit_ui : public initquit
{
	virtual void on_init()
	{
		WNDCLASS wcls;

		wcls.style             = 0 ;
		wcls.cbClsExtra        = 0 ;
		wcls.cbWndExtra        = 16 ;
		wcls.hbrBackground     = ( HBRUSH )NULL ;
		wcls.hIcon             = 0 ;
		wcls.hCursor           = NULL ;
		wcls.lpszMenuName      = _T( "" ) ;
		wcls.lpfnWndProc = foo_PlaylistRemoteWndProc ;
		wcls.hInstance = core_api::get_my_instance() ;
		wcls.lpszClassName = FOO_PLAYLIST_REMOTE_WND_CLASS ;

		RegisterClass( &wcls ) ;

		g_hwnd = CreateWindow( FOO_PLAYLIST_REMOTE_WND_CLASS, FOO_PLAYLIST_REMOTE_WND_NAME,
								WS_POPUP, 0, 0, 10, 10, NULL, NULL,
								core_api::get_my_instance(), NULL ) ;
	}

	virtual void on_quit()
	{
/*		if ( current_track != NULL )
		{
			current_track->handle_release() ;
			current_track = NULL ;
		}*/

		//DistributeSingle( FOO_ACTION_QUIT ) ;

		g_set_sub.clear() ;

		if ( g_hwnd )
		{
			DestroyWindow( g_hwnd ) ;
			g_hwnd = NULL ;
		}
	}
};

// quit callback
static service_factory_single_t<initquit_ui> foo_init_quit ;

// plug-in version
DECLARE_COMPONENT_VERSION( "Playlist Remote Control", "0.0.3", 0 ) ;
